diff --git a/test/unit/web/app_bundle_test.rb b/test/unit/web/app_bundle_test.rb
new file mode 100644
index 00000000..9b8ddb8e
--- /dev/null
+++ b/test/unit/web/app_bundle_test.rb
@@ -0,0 +1,153 @@
+require "test_helper"
+require "digest"
+require "zlib"
+require "rubygems/package"
+require "hive/web/app_bundle"
+
+class WebAppBundleTest < Minitest::Test
+  include HiveTestHelper
+
+  def web_archive(path, version:)
+    files = {
+      ".hive-web-version" => "#{version}\n",
+      "Gemfile" => "source \"https://rubygems.org\"\n",
+      "Gemfile.lock" => "GEM\n  specs:\n    psych (#{Psych::VERSION})\n",
+      "config/application.rb" => "# app\n",
+      "bin/rails" => "#!/bin/sh\nexit 0\n"
+    }
+    Zlib::GzipWriter.open(path) do |gzip|
+      Gem::Package::TarWriter.new(gzip) do |tar|
+        tar.mkdir("config", 0o755)
+        tar.mkdir("bin", 0o755)
+        files.each do |name, body|
+          mode = name == "bin/rails" ? 0o755 : 0o644
+          tar.add_file_simple(name, mode, body.bytesize) { |io| io.write(body) }
+        end
+      end
+    end
+  end
+
+  def test_custom_url_requires_sha256
+    error = assert_raises(Hive::Error) do
+      Hive::Web::AppBundle.new(url: "https://example.test/web.tgz")
+    end
+    assert_match(/SHA-256/, error.message)
+  end
+
+  def test_current_bundle_is_reused_without_download
+    with_xdg_home do
+      active = Hive::Paths.web_app_home
+      FileUtils.mkdir_p(File.join(active, "config"))
+      FileUtils.mkdir_p(File.join(active, "bin"))
+      File.write(File.join(active, ".hive-web-version"), "#{Hive::VERSION}\n")
+      File.write(File.join(active, "Gemfile"), "source \"https://rubygems.org\"\n")
+      File.write(File.join(active, "Gemfile.lock"), "GEM\n")
+      File.write(File.join(active, "config", "application.rb"), "# app\n")
+      File.write(File.join(active, "bin", "rails"), "#!/bin/sh\n")
+      FileUtils.chmod(0o755, File.join(active, "bin", "rails"))
+      downloads = 0
+      bundle = Hive::Web::AppBundle.new(
+        downloader: ->(*) { downloads += 1 },
+        runner: ->(*) { true }
+      )
+
+      assert_equal active, bundle.install!
+      assert_equal 0, downloads
+    end
+  end
+
+  def test_matching_marker_does_not_reuse_a_partial_bundle
+    with_xdg_home do
+      active = Hive::Paths.web_app_home
+      FileUtils.mkdir_p(active)
+      File.write(File.join(active, ".hive-web-version"), "#{Hive::VERSION}\n")
+
+      refute Hive::Web::AppBundle.new(
+        downloader: ->(*) { raise "download proves repair was attempted" }
+      ).current?
+      error = assert_raises(Hive::Error) do
+        Hive::Web::AppBundle.new(
+          downloader: ->(*) { raise "download proves repair was attempted" }
+        ).install!
+      end
+      assert_match(/repair was attempted/, error.message)
+    end
+  end
+
+  def test_default_release_fails_closed_without_cosign
+    with_xdg_home do |dir|
+      archive = File.join(dir, "asset.tgz")
+      web_archive(archive, version: Hive::VERSION)
+      downloader = lambda do |url, target|
+        if url.end_with?(".tar.gz")
+          FileUtils.cp(archive, target)
+        else
+          File.write(target, "#{Digest::SHA256.file(archive).hexdigest}  hive-web-#{Hive::VERSION}.tar.gz\n")
+        end
+      end
+
+      with_env("PATH" => "") do
+        error = assert_raises(Hive::Error) do
+          Hive::Web::AppBundle.new(downloader: downloader).install!
+        end
+        assert_match(/cosign is required/, error.message)
+      end
+    end
+  end
+
+  def test_custom_bundle_url_and_sha_can_be_supplied_by_environment
+    with_env(
+      "HIVE_WEB_BUNDLE_URL" => "https://packages.example.invalid/hive-web.tgz",
+      "HIVE_WEB_BUNDLE_SHA256" => "a" * 64
+    ) do
+      bundle = Hive::Web::AppBundle.new
+
+      assert_equal "https://packages.example.invalid/hive-web.tgz", bundle.url
+    end
+  end
+
+  def test_verified_bundle_is_prepared_and_activated
+    with_xdg_home do |dir|
+      archive = File.join(dir, "asset.tgz")
+      web_archive(archive, version: Hive::VERSION)
+      calls = []
+      bundle = Hive::Web::AppBundle.new(
+        url: "https://example.test/web.tgz",
+        sha256: Digest::SHA256.file(archive).hexdigest,
+        downloader: ->(_url, target) { FileUtils.cp(archive, target) },
+        runner: ->(env, argv, chdir:) { calls << [ env, argv, chdir ]; true }
+      )
+
+      active = bundle.install!
+
+      assert_equal Hive::VERSION, File.read(File.join(active, ".hive-web-version")).strip
+      psych_link = Dir[File.join(Hive::Paths.web_gems_home, "ruby", Gem.ruby_api_version,
+                                 "specifications", "psych-*.gemspec")].first
+      assert File.symlink?(psych_link), "matching default psych should be linked into BUNDLE_PATH"
+      assert_equal 3, calls.length
+      assert_equal Hive::Paths.web_gems_home, calls.first.first.fetch("BUNDLE_PATH")
+      assert_equal "development:test", calls.first.first.fetch("BUNDLE_WITHOUT")
+      assert_equal "1", calls.first.first.fetch("SECRET_KEY_BASE_DUMMY")
+      assert_equal Hive::Paths.web_storage_home, calls.last.first.fetch("HIVE_WEB_STORAGE_DIR")
+    end
+  end
+
+  def test_checksum_failure_preserves_previous_bundle
+    with_xdg_home do |dir|
+      active = Hive::Paths.web_app_home
+      FileUtils.mkdir_p(active)
+      File.write(File.join(active, ".hive-web-version"), "old\n")
+      archive = File.join(dir, "asset.tgz")
+      web_archive(archive, version: Hive::VERSION)
+      bundle = Hive::Web::AppBundle.new(
+        url: "https://example.test/web.tgz",
+        sha256: "0" * 64,
+        downloader: ->(_url, target) { FileUtils.cp(archive, target) },
+        runner: ->(*) { true }
+      )
+
+      assert_raises(Hive::Error) { bundle.install! }
+      assert_equal "old", File.read(File.join(active, ".hive-web-version")).strip
+    end
+  end
+end
diff --git a/test/unit/web/archive_validator_test.rb b/test/unit/web/archive_validator_test.rb
new file mode 100644
index 00000000..8fc2648a
--- /dev/null
+++ b/test/unit/web/archive_validator_test.rb
@@ -0,0 +1,64 @@
+require "test_helper"
+require "zlib"
+require "rubygems/package"
+require "hive/web/archive_validator"
+
+class WebArchiveValidatorTest < Minitest::Test
+  include HiveTestHelper
+
+  def build_archive(path)
+    Zlib::GzipWriter.open(path) do |gzip|
+      Gem::Package::TarWriter.new(gzip) { |tar| yield tar }
+    end
+  end
+
+  def test_extracts_regular_files_inside_destination
+    with_tmp_dir do |dir|
+      archive = File.join(dir, "web.tgz")
+      build_archive(archive) do |tar|
+        tar.mkdir(".", 0o755)
+        tar.mkdir("config", 0o755)
+        body = "Rails.application\n"
+        tar.add_file_simple("config/application.rb", 0o644, body.bytesize) { |io| io.write(body) }
+      end
+      destination = File.join(dir, "out")
+
+      Hive::Web::ArchiveValidator.new(archive).extract_to(destination)
+
+      assert_equal "Rails.application\n", File.read(File.join(destination, "config/application.rb"))
+    end
+  end
+
+  def test_rejects_parent_traversal
+    with_tmp_dir do |dir|
+      archive = File.join(dir, "bad.tgz")
+      build_archive(archive) do |tar|
+        tar.add_file_simple("../escaped", 0o644, 1) { |io| io.write("x") }
+      end
+
+      error = assert_raises(Hive::Error) do
+        Hive::Web::ArchiveValidator.new(archive).extract_to(File.join(dir, "out"))
+      end
+      assert_match(/unsafe archive path/, error.message)
+      refute File.exist?(File.join(dir, "escaped"))
+    end
+  end
+
+  def test_rejects_links_and_setuid_modes
+    with_tmp_dir do |dir|
+      link_archive = File.join(dir, "link.tgz")
+      build_archive(link_archive) { |tar| tar.add_symlink("escape", "../outside", 0o777) }
+      assert_raises(Hive::Error) do
+        Hive::Web::ArchiveValidator.new(link_archive).extract_to(File.join(dir, "links"))
+      end
+
+      mode_archive = File.join(dir, "mode.tgz")
+      build_archive(mode_archive) do |tar|
+        tar.add_file_simple("danger", 0o4755, 1) { |io| io.write("x") }
+      end
+      assert_raises(Hive::Error) do
+        Hive::Web::ArchiveValidator.new(mode_archive).extract_to(File.join(dir, "modes"))
+      end
+    end
+  end
+end
diff --git a/test/unit/web/daemon_maintenance_test.rb b/test/unit/web/daemon_maintenance_test.rb
new file mode 100644
index 00000000..579afb1d
--- /dev/null
+++ b/test/unit/web/daemon_maintenance_test.rb
@@ -0,0 +1,53 @@
+require "test_helper"
+require "hive/web/daemon_maintenance"
+
+class WebDaemonMaintenanceTest < Minitest::Test
+  include HiveTestHelper
+
+  class Installer
+    attr_reader :calls
+
+    def initialize
+      @calls = []
+    end
+
+    def install!(autostart:, force:)
+      @calls << [ :install, autostart, force ]
+      Hive::Commands::ServiceInstaller::Outcome.new(:written)
+    end
+
+    def stop! = @calls << [ :stop ]
+    def start! = @calls << [ :start ]
+  end
+
+  def test_allows_only_fixed_repair_and_restart_operations
+    with_xdg_home do
+      installer = Installer.new
+      maintenance = Hive::Web::DaemonMaintenance.new(installer: installer, active_tasks: -> { [] })
+
+      assert maintenance.call("repair").fetch("ok")
+      assert_equal [ :install, true, true ], installer.calls.first
+      assert_raises(Hive::InvalidTaskPath) { maintenance.call("rm -rf") }
+    end
+  end
+
+  def test_refuses_restart_and_repair_while_agents_are_active
+    with_xdg_home do
+      installer = Installer.new
+      task = { "project" => "demo", "slug" => "ship-it", "stage" => "4-execute" }
+      maintenance = Hive::Web::DaemonMaintenance.new(
+        installer: installer,
+        active_tasks: -> { [ task ] }
+      )
+
+      %w[restart repair].each do |action|
+        result = maintenance.call(action)
+        refute result.fetch("ok")
+        assert result.fetch("refused")
+        assert_equal [ task ], result.fetch("active_tasks")
+        assert_equal 0, result.fetch("forced_interruptions")
+      end
+      assert_empty installer.calls
+    end
+  end
+end
diff --git a/test/unit/web/environment_test.rb b/test/unit/web/environment_test.rb
new file mode 100644
index 00000000..d225f80a
--- /dev/null
+++ b/test/unit/web/environment_test.rb
@@ -0,0 +1,89 @@
+require "test_helper"
+require "hive/web/environment"
+
+class WebEnvironmentTest < Minitest::Test
+  include HiveTestHelper
+
+  def base_config
+    {
+      "bind" => "127.0.0.1",
+      "port" => 4567,
+      "origin" => "http://127.0.0.1:4567",
+      "github" => { "owner" => nil },
+      "session_secret_file" => File.join(Dir.tmpdir, "secret")
+    }
+  end
+
+  def test_canonical_environment_wins_over_hivebox_aliases
+    with_env(
+      "HIVE_WEB_BIND" => "127.0.0.2",
+      "HIVEBOX_BIND" => "0.0.0.0",
+      "HIVE_WEB_PORT" => "5678",
+      "HIVEBOX_PORT" => "6789"
+    ) do
+      environment = Hive::Web::Environment.new(config: base_config)
+
+      assert_equal "127.0.0.2", environment.bind
+      assert_equal 5678, environment.port
+    end
+  end
+
+  def test_non_loopback_requires_auth_flow_or_unsafe
+    error = assert_raises(Hive::Error) do
+      Hive::Web::Environment.new(config: base_config, bind: "0.0.0.0").validate_security!
+    end
+    assert_match(/refusing non-loopback bind/, error.message)
+
+    claimable = base_config.merge("github" => { "owner" => nil, "client_id" => "device-flow-client" })
+    assert Hive::Web::Environment.new(config: claimable, bind: "0.0.0.0").validate_security!
+    assert Hive::Web::Environment.new(config: base_config, bind: "0.0.0.0", unsafe: true).validate_security!
+  end
+
+  def test_rails_env_contains_real_xdg_roots_and_compatibility_aliases
+    with_xdg_home do
+      environment = Hive::Web::Environment.new(config: base_config)
+      env = environment.to_h(app_dir: "/tmp/web", cli_root: "/tmp/hive")
+
+      assert_equal Hive::Paths.config_home, env.fetch("HIVE_CONFIG_HOME")
+      refute env.key?("HIVE_WEB_STORAGE_DIR")
+      refute env.key?("HIVEBOX_STORAGE_DIR")
+      assert_equal "true", env.fetch("HIVE_WEB_LOCAL_MODE")
+      assert_equal "/tmp/hive", env.fetch("HIVE_CLI_ROOT")
+      refute env.key?("BUNDLE_PATH")
+      refute env.key?("BUNDLE_WITHOUT")
+    end
+  end
+
+  def test_managed_mode_uses_managed_bundle_path_without_changing_source_mode
+    with_xdg_home do
+      environment = Hive::Web::Environment.new(config: base_config)
+      managed = environment.to_h(app_dir: "/tmp/web", cli_root: "/tmp/hive", managed: true)
+
+      assert_equal Hive::Paths.web_gems_home, managed.fetch("BUNDLE_PATH")
+      assert_equal "development:test", managed.fetch("BUNDLE_WITHOUT")
+      assert_equal Hive::Paths.web_storage_home, managed.fetch("HIVE_WEB_STORAGE_DIR")
+      assert_equal managed.fetch("HIVE_WEB_STORAGE_DIR"), managed.fetch("HIVEBOX_STORAGE_DIR")
+    end
+  end
+
+  def test_canonical_storage_wins_but_legacy_hivebox_storage_is_preserved
+    with_xdg_home do
+      with_env("HIVE_WEB_STORAGE_DIR" => nil, "HIVEBOX_STORAGE_DIR" => "/data/legacy") do
+        env = Hive::Web::Environment.new(config: base_config)
+                                    .to_h(app_dir: "/app", cli_root: "/hive")
+        assert_equal "/data/legacy", env.fetch("HIVE_WEB_STORAGE_DIR")
+        assert_equal "/data/legacy", env.fetch("HIVEBOX_STORAGE_DIR")
+      end
+
+      with_env(
+        "HIVE_WEB_STORAGE_DIR" => "/state/canonical",
+        "HIVEBOX_STORAGE_DIR" => "/data/legacy"
+      ) do
+        env = Hive::Web::Environment.new(config: base_config)
+                                    .to_h(app_dir: "/app", cli_root: "/hive")
+        assert_equal "/state/canonical", env.fetch("HIVE_WEB_STORAGE_DIR")
+        assert_equal "/state/canonical", env.fetch("HIVEBOX_STORAGE_DIR")
+      end
+    end
+  end
+end
diff --git a/test/unit/web/host_authorization_test.rb b/test/unit/web/host_authorization_test.rb
new file mode 100644
index 00000000..1ec7ad2f
--- /dev/null
+++ b/test/unit/web/host_authorization_test.rb
@@ -0,0 +1,28 @@
+require "test_helper"
+require "hive/web/host_authorization"
+
+class WebHostAuthorizationTest < Minitest::Test
+  def test_allows_complete_loopback_range_and_configured_hosts
+    hosts = Hive::Web::HostAuthorization.allowed_hosts(
+      bind: "0.0.0.0",
+      origin: "https://hive.internal.example:4567"
+    )
+
+    assert_includes hosts, "localhost"
+    assert hosts.any? { |host| host.is_a?(IPAddr) && host.include?("127.0.0.2") }
+    assert hosts.any? { |host| host.is_a?(IPAddr) && host.include?("::1") }
+    assert hosts.any? { |host| host.is_a?(IPAddr) && host.include?("192.0.2.10") }
+    assert_includes hosts, "hive.internal.example"
+    refute_includes hosts, "attacker.example"
+  end
+
+  def test_ignores_an_invalid_origin_without_disabling_authorization
+    hosts = Hive::Web::HostAuthorization.allowed_hosts(
+      bind: "127.0.0.1",
+      origin: "not a valid URI"
+    )
+
+    assert_includes hosts, "127.0.0.1"
+    refute_includes hosts, nil
+  end
+end
diff --git a/test/unit/web/loopback_test.rb b/test/unit/web/loopback_test.rb
new file mode 100644
index 00000000..84ab6ba6
--- /dev/null
+++ b/test/unit/web/loopback_test.rb
@@ -0,0 +1,13 @@
+require "test_helper"
+require "hive/web/loopback"
+
+class WebLoopbackTest < Minitest::Test
+  def test_accepts_only_loopback_addresses
+    assert Hive::Web::Loopback.address?("127.0.0.1")
+    assert Hive::Web::Loopback.address?("::1")
+    assert Hive::Web::Loopback.address?("localhost")
+    refute Hive::Web::Loopback.address?("0.0.0.0")
+    refute Hive::Web::Loopback.address?("192.168.1.10")
+    refute Hive::Web::Loopback.address?("example.test")
+  end
+end
diff --git a/test/unit/web/service_status_test.rb b/test/unit/web/service_status_test.rb
new file mode 100644
index 00000000..58f5267e
--- /dev/null
+++ b/test/unit/web/service_status_test.rb
@@ -0,0 +1,72 @@
+require "test_helper"
+require "hive/web/service_status"
+
+class WebServiceStatusTest < Minitest::Test
+  class Installer
+    def service_state
+      {
+        "platform" => "linux", "unit_path" => "/tmp/hive-web.service",
+        "service_installed" => true, "service_enabled" => true
+      }
+    end
+
+    def running? = true
+    def service_manager_available? = true
+
+    def installed_settings
+      {
+        "readable" => true,
+        "bind" => "127.0.0.1",
+        "port" => 4567,
+        "unsafe" => false,
+        "url" => "http://127.0.0.1:4567",
+        "configuration_drift" => false,
+        "message" => nil
+      }
+    end
+  end
+
+  def test_running_is_not_ready_without_health
+    status = Hive::Web::ServiceStatus.new(
+      installer: Installer.new,
+      http_get: ->(_uri) { false },
+      url: "http://127.0.0.1:4567"
+    ).to_h
+
+    assert status.fetch("running")
+    refute status.fetch("ready")
+    assert_equal "health_failed", status.fetch("failure")
+  end
+
+  def test_ready_requires_service_and_health
+    status = Hive::Web::ServiceStatus.new(
+      installer: Installer.new,
+      http_get: ->(_uri) { true },
+      url: "http://127.0.0.1:4567"
+    ).to_h
+
+    assert status.fetch("ready")
+    assert_nil status.fetch("failure")
+  end
+
+  def test_installed_definition_is_probed_and_configuration_drift_is_actionable
+    installer = Installer.new
+    installer.define_singleton_method(:installed_settings) do
+      super().merge(
+        "port" => 5678,
+        "url" => "http://127.0.0.1:5678",
+        "configuration_drift" => true
+      )
+    end
+    status = Hive::Web::ServiceStatus.new(
+      installer: installer,
+      http_get: ->(uri) { uri.port == 5678 },
+      url: "http://127.0.0.1:4567"
+    ).to_h
+
+    assert_equal "http://127.0.0.1:5678", status.fetch("url")
+    assert_equal "http://127.0.0.1:4567", status.fetch("desired_url")
+    refute status.fetch("ready")
+    assert_equal "configuration_drift", status.fetch("failure")
+  end
+end
diff --git a/test/unit/web/web_command_test.rb b/test/unit/web/web_command_test.rb
index 11de4ab0..8fd407c9 100644
--- a/test/unit/web/web_command_test.rb
+++ b/test/unit/web/web_command_test.rb
@@ -4,20 +4,19 @@ require "hive/commands/web"
 class WebCommandTest < Minitest::Test
   include HiveTestHelper
 
-  # `hive web` now boots the Rails app under web/; outside the container or
-  # a source checkout (no web/ dir, no HIVEBOX_WEB_APP_DIR) it must fail
-  # loudly with guidance instead of exec-ing into a missing app.
-  def test_missing_rails_app_exits_with_guidance
+  # Outside Docker/source, the command bootstraps the managed release bundle.
+  # A failed acquisition remains a typed CLI error rather than a raw backtrace.
+  def test_missing_rails_app_bundle_failure_is_typed
     with_tmp_global_config do
       with_env("HIVEBOX_WEB_APP_DIR" => File.join(Dir.mktmpdir("hive-noapp"), "nope")) do
         command = Hive::Commands::Web.new
-        # Singleton override instead of minitest/mock (not bundled): the
-        # checkout itself contains web/, so the fallback path would resolve.
-        command.define_singleton_method(:rails_app_dir) { nil }
-        err = assert_raises(SystemExit) do
+        command.define_singleton_method(:resolve_rails_app_dir) do
+          raise Hive::Error, "hive web: matching bundle could not be installed"
+        end
+        err = assert_raises(Hive::Error) do
           capture_io { command.call }
         end
-        assert_equal 1, err.status, "a missing web app must exit 1"
+        assert_match(/matching bundle/, err.message)
       end
     end
   end
@@ -34,18 +33,26 @@ class WebCommandTest < Minitest::Test
     end
   end
 
-  def test_public_bind_without_https_origin_warns
+  def test_public_bind_allows_fresh_claim_flow_but_refuses_missing_auth
     with_tmp_global_config do
-      command = Hive::Commands::Web.new
-      _out, err = capture_io do
-        command.send(:warn_on_public_bind, "0.0.0.0", { "origin" => "http://example.test" })
+      claimable = Hive::Commands::Web.new(bind: "0.0.0.0")
+      assert claimable.send(
+        :web_environment,
+        Hive::Config.load_global_web
+      ).validate_security!
+
+      command = Hive::Commands::Web.new(bind: "0.0.0.0")
+      no_auth = Hive::Config.load_global_web.merge("github" => { "owner" => nil, "client_id" => nil })
+      error = assert_raises(Hive::Error) do
+        command.send(:web_environment, no_auth).validate_security!
       end
-      assert_match(/WARNING binding 0.0.0.0/, err, "plain-http public bind must warn about Host validation")
+      assert_match(/refusing non-loopback bind/, error.message)
 
+      unsafe = Hive::Commands::Web.new(bind: "0.0.0.0", unsafe: true)
       _out, err = capture_io do
-        command.send(:warn_on_public_bind, "0.0.0.0", { "origin" => "https://example.test" })
+        unsafe.send(:web_environment, no_auth).validate_security!
       end
-      assert_empty err, "an https origin implies a fronting proxy — no warning"
+      assert_match(/UNSAFE/, err)
     end
   end
   # Drive the full "app found" path with a stub Rails app: db:prepare
@@ -86,7 +93,7 @@ class WebCommandTest < Minitest::Test
           capture_io { Hive::Commands::Web.new.call }
         end
         assert_match(/db:prepare failed/, error.message)
-        assert_match(/writable/, error.message, "the message must point at the /data mount")
+        assert_match(/writable/, error.message, "the message must identify the source storage path")
       end
     end
   end
@@ -102,8 +109,10 @@ class WebCommandTest < Minitest::Test
         caught = nil
         begin
           capture_io { Hive::Commands::Web.new.call }
-        rescue ExecCaught => e
-          caught = e
+        rescue Hive::Error => e
+          raise unless e.cause.is_a?(ExecCaught)
+
+          caught = e.cause
         ensure
           Kernel.define_singleton_method(:exec, original)
         end
@@ -111,8 +120,57 @@ class WebCommandTest < Minitest::Test
         refute_nil caught, "the command must end in Kernel.exec of the rails server"
         assert_equal %w[bin/rails server -b], caught.argv[0..2]
         assert caught.env.key?("SECRET_KEY_BASE"), "the persisted session secret must reach Rails"
-        assert caught.env.key?("HIVEBOX_STORAGE_DIR")
+        refute caught.env.key?("HIVEBOX_STORAGE_DIR"),
+               "source execution without an override must retain Rails' in-app storage default"
+        assert_equal File.expand_path("../../../bin/hive", __dir__),
+                     caught.env.fetch("HIVE_INVOKED_BIN")
+        refute caught.env.key?("BUNDLE_PATH"), "source execution must retain its own bundle"
       end
     end
   end
+
+  def test_successful_stop_json_reports_operation_success
+    command = Hive::Commands::Web.new("stop", json: true)
+    installer = Object.new
+    installer.define_singleton_method(:stop!) { true }
+    status = {
+      "platform" => "linux",
+      "unit_path" => "/tmp/hive-web.service",
+      "service_installed" => true,
+      "service_enabled" => true,
+      "running" => false,
+      "ready" => false,
+      "url" => "http://127.0.0.1:4567",
+      "failure" => "process_not_running"
+    }
+    command.define_singleton_method(:service_installer) { installer }
+    command.define_singleton_method(:service_status) do |_installer|
+      value = status
+      Object.new.tap { |object| object.define_singleton_method(:to_h) { value } }
+    end
+
+    out, _err = capture_io { command.call }
+    payload = JSON.parse(out)
+
+    assert_equal true, payload.fetch("ok")
+    assert_equal "stop", payload.fetch("operation")
+    assert_equal false, payload.fetch("ready")
+  end
+
+  def test_lifecycle_failure_json_has_the_status_schema_shape
+    command = Hive::Commands::Web.new("start", json: true)
+    installer = Object.new
+    installer.define_singleton_method(:service_state) { { "service_installed" => false } }
+    command.define_singleton_method(:service_installer) { installer }
+
+    out, _err, status = with_captured_exit { command.call }
+    payload = JSON.parse(out)
+
+    refute_equal 0, status
+    assert_equal "hive-web-status", payload.fetch("schema")
+    assert_equal false, payload.fetch("ok")
+    assert_equal "start", payload.fetch("operation")
+    assert_equal "command_failed", payload.fetch("failure")
+    assert_equal false, payload.fetch("running")
+  end
 end
diff --git a/web/Gemfile b/web/Gemfile
index 53710d90..7b552a75 100644
--- a/web/Gemfile
+++ b/web/Gemfile
@@ -70,4 +70,4 @@ end
 # The hive control plane: status payloads, gate approval, daemon dispatch,
 # the GitHub device-flow gate, the agent OAuth relay, and Telegram
 # validation all come from the gem — the web tier adds no pipeline logic.
-gem "hive-cli", path: ".."
+gem "hive-cli", path: ENV["HIVE_CLI_ROOT"] || ".."
diff --git a/web/app/controllers/application_controller.rb b/web/app/controllers/application_controller.rb
index 2a1e5e28..fa53e193 100644
--- a/web/app/controllers/application_controller.rb
+++ b/web/app/controllers/application_controller.rb
@@ -50,6 +50,7 @@ class ApplicationController < ActionController::Base
   end
 
   def require_login
+    return if local_loopback_request?
     return redirect_to login_path unless current_login
 
     # Sessions must track the CURRENT owner, not the owner at sign-in time:
@@ -65,6 +66,23 @@ class ApplicationController < ActionController::Base
     redirect_to login_path, alert: "Signed out: this box's owner changed."
   end
 
+  def local_loopback_request?
+    return false unless Rails.application.config.x.hive_web_local_mode
+
+    bind = Rails.application.config.x.hive_web_bind.to_s
+    return false unless loopback_address?(bind)
+
+    # REMOTE_ADDR is the socket peer. Deliberately ignore X-Forwarded-For:
+    # a proxy header must never manufacture the local no-auth bypass.
+    loopback_address?(request.get_header("REMOTE_ADDR"))
+  end
+
+  def loopback_address?(value)
+    value.to_s.casecmp("localhost").zero? || IPAddr.new(value.to_s).loopback?
+  rescue IPAddr::InvalidAddressError
+    false
+  end
+
   def registered_projects
     @registered_projects ||= Hive::Config.registered_projects
   end
diff --git a/web/app/controllers/daemon_controller.rb b/web/app/controllers/daemon_controller.rb
new file mode 100644
index 00000000..61ad5050
--- /dev/null
+++ b/web/app/controllers/daemon_controller.rb
@@ -0,0 +1,28 @@
+class DaemonController < ApplicationController
+  def maintain
+    operation = params.require(:operation)
+    require "hive/invoked_binary"
+    require "hive/commands/daemon/service_installer"
+    require "hive/web/daemon_maintenance"
+    binary = Hive::InvokedBinary.path
+    raise Hive::Error, "cannot identify the Hive executable used to launch the web service" unless binary
+
+    installer = Hive::Commands::Daemon::ServiceInstaller.new(
+      binary_path: binary
+    )
+    result = Hive::Web::DaemonMaintenance.new(installer: installer).call(operation)
+    payload = {
+      "schema" => "hive-daemon-maintenance",
+      "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-daemon-maintenance")
+    }.merge(result)
+
+    respond_to do |format|
+      format.html do
+        redirect_to root_path,
+                    notice: result["ok"] ? result["message"] : nil,
+                    alert: result["ok"] ? nil : result["message"]
+      end
+      format.json { render json: payload, status: result["ok"] ? :ok : :service_unavailable }
+    end
+  end
+end
diff --git a/web/app/controllers/status_controller.rb b/web/app/controllers/status_controller.rb
index c44440a8..ebdec5ee 100644
--- a/web/app/controllers/status_controller.rb
+++ b/web/app/controllers/status_controller.rb
@@ -2,5 +2,27 @@ class StatusController < ApplicationController
   def index
     @payload = StatusBroadcaster.snapshot
     @projects = @payload.fetch("projects", [])
+    @daemon_report = daemon_report
+  end
+
+  private
+
+  class DaemonProbe
+    include Hive::PidFile
+
+    def pid_file
+      File.join(Hive::Paths.state_home, ".daemon.pid")
+    end
+  end
+
+  def daemon_report
+    require "hive/daemon/status_report"
+    require "hive/commands/daemon/service_installer"
+    Hive::Daemon::StatusReport.new(
+      installer: Hive::Commands::Daemon::ServiceInstaller.new,
+      pid_probe: DaemonProbe.new,
+      pid_file: File.join(Hive::Paths.state_home, ".daemon.pid"),
+      log_file: File.join(Hive::Paths.state_home, "logs", "daemon.log")
+    ).to_h
   end
 end
diff --git a/web/app/views/status/_daemon.html.erb b/web/app/views/status/_daemon.html.erb
new file mode 100644
index 00000000..cb759d28
--- /dev/null
+++ b/web/app/views/status/_daemon.html.erb
@@ -0,0 +1,38 @@
+<section class="daemon-card" aria-labelledby="daemon-heading">
+  <div>
+    <h2 id="daemon-heading">Daemon</h2>
+    <p>
+      <strong><%= daemon["ready"] ? "Ready" : (daemon["running"] ? "Running with service issue" : "Stopped") %></strong>
+      · service <%= daemon["service_enabled"] ? "enabled" : "not enabled" %>
+      · drift <code><%= daemon["drift"] %></code>
+    </p>
+    <p class="daemon-paths">
+      Installed: <code><%= daemon["installed_executable"] || "not detected" %></code>
+      (<%= daemon["installed_version"] || "unknown version" %>)<br>
+      Current: <code><%= daemon["current_executable"] %></code>
+      (<%= daemon["current_version"] %>)
+    </p>
+    <% if daemon["drift_message"].present? %>
+      <p class="daemon-diagnostic"><strong>Why:</strong> <%= daemon["drift_message"] %></p>
+    <% end %>
+    <% if daemon["last_maintenance"] %>
+      <p>Last action: <%= daemon.dig("last_maintenance", "message") %></p>
+    <% end %>
+  </div>
+  <div class="daemon-actions">
+    <% repair_recommended = daemon["drift"] != "none" ||
+                            daemon["service_installed"] != true ||
+                            daemon["service_enabled"] != true %>
+    <% if repair_recommended %>
+      <p>Recommended: repair the service definition with the current Hive executable.</p>
+      <%= button_to "Repair service", daemon_maintenance_path("repair"),
+            method: :post, class: "btn btn-sm",
+            form: { data: { turbo_confirm: "Repair the daemon service? This refuses while agents are active." } } %>
+    <% else %>
+      <p>Recommended: restart the healthy service only if its process needs refreshing.</p>
+      <%= button_to "Restart", daemon_maintenance_path("restart"),
+            method: :post, class: "btn btn-ghost btn-sm",
+            form: { data: { turbo_confirm: "Restart the Hive daemon? This refuses while agents are active." } } %>
+    <% end %>
+  </div>
+</section>
diff --git a/web/app/views/status/index.html.erb b/web/app/views/status/index.html.erb
index 25bcdf79..cc48afd0 100644
--- a/web/app/views/status/index.html.erb
+++ b/web/app/views/status/index.html.erb
@@ -26,6 +26,8 @@
   </aside>
   <div class="status-main">
 
+<%= render "status/daemon", daemon: @daemon_report %>
+
 <%# data-turbo-permanent: a morph must never touch the composer — it holds
     typed-but-unsent idea text and staged image attachments (Stimulus state
     the server can't re-render). %>
